﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices;

namespace CH372UpDown
{
    public partial class Form1 : Form
    {
        UInt32 mIndex = 0;//设备序号
        UInt32 m_downlen2 = 0;//端点2下传长度
        UInt32 m_uplen1 = 8;//端点1上传长度
        UInt32 m_uplen2 = 64;//端点2上传长度
        UInt32 DownCount = 0;//端点2累计下传长度
        UInt32 UpCount = 0;//端点2累计上传长度
        UInt32 InterCount = 0;//端点1累计上传长度
        bool m_trdup1 = false;//端点1上传线程启动标志
        bool m_trdup2 = false;//端点2上传线程启动标志
        bool m_trddown2 = false;//端点2下传线程启动标志
        bool m_open = false;//设备打开
        bool m_close = true;//设备关闭
        IntPtr T2DHandle = new IntPtr(-1);//端点2下传设备打开句柄
        IntPtr T2UHandle = new IntPtr(-1);//端点2上传设备打开句柄
        IntPtr T1Handle = new IntPtr(-1);//端点1上传设备打开句柄
        IntPtr DevHandle = new IntPtr(-1);//设备句柄
        [ThreadStatic]
        private static CH375DLL.mPCH375_NOTIFY_ROUTINE NOTIFY_ROUTINE;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Control.CheckForIllegalCrossThreadCalls = false;
            for (uint i = 0; i < CH375DLL.mCH375_MAX_NUMBER; i++)
            {//ComboBox填充设备序号(0-15)	
                this.comboBox_DevIndex.Items.Add(i.ToString("d"));
                if (CH375DLL.CH375OpenDevice(i) != new IntPtr(-1))
                {//初始化时检测是否有已插入的CH372/CH375设备
                    this.textBox_DeviceStatus.Text = "检测到有CH372/CH375设备已插入.";
                    CH375DLL.CH375CloseDevice(i);
                }
            }
            NOTIFY_ROUTINE = new CH375DLL.mPCH375_NOTIFY_ROUTINE(CH375NOTIFYROUTINE);
            this.comboBox_DevIndex.SelectedIndex = 0;
            CH375DLL.CH375SetDeviceNotify(0, null, NOTIFY_ROUTINE);//启动指定序号设备插拔监视
            
        }
        public void CH375NOTIFYROUTINE(UInt32 iEventStatus)
        { 
	        if(iEventStatus==CH375DLL.CH375_DEVICE_ARRIVAL)
            { //检测到设备插入事件
		        this.textBox_DeviceStatus.Text=string.Format("检测到有CH372/CH375设备已插入.");
	        }
	        else if(iEventStatus==CH375DLL.CH375_DEVICE_REMOVE)
            {//检测到设备拔出事件
                this.textBox_DeviceStatus.Text=string.Format("检测到有CH372/CH375设备已拔出.");
                if (DevHandle != new IntPtr(-1))
                {
                    OnOpenCH375Device();//等效于单击打开设备按钮	
                }
	        }
	        return;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            OnOpenCH375Device();
        }
        public void OnOpenCH375Device()
        {
            uint DeviceID = 0;
            if (m_open)
            { //设备已被打开,先关闭		
                mCloseWin();
                string str = string.Format("厂商ID:{0:X4},设备ID:{1:X4}", 0, 0);
                this.textBox_DeviceInfo.Text = str;
                m_open = false;
            }
            else
            {
                mIndex = (uint)this.comboBox_DevIndex.SelectedIndex;
                // 使用之前必须打开设备
                DevHandle = CH375DLL.CH375OpenDevice(mIndex);
                if (DevHandle == new IntPtr(-1))
                {
                    m_open = false;
                    string str = string.Format("打开{0:D}#设备失败!", mIndex);
                    MessageBox.Show(str, "DEBUG372");
                    return;
                }
                m_open = true;
                DeviceID = CH375DLL.CH375GetUsbID(mIndex); //获取当前打开的USB设备ID,返回数据中,低16位为厂商ID,高16位为产品ID,错误时返回全0(无效ID)
                ushort PID = (ushort)(DeviceID & 0xffff);
                ushort VID = (ushort)((DeviceID >> 16) & 0xffff);
                this.textBox_DeviceInfo.Text = string.Format("厂商ID:{0:X4},设备ID:{1:X4}", PID, VID);
                this.button_OpenDev.Text = string.Format("关闭{0:D}#设备", mIndex);
            }
            return;
        }
        public void mCloseWin()
        {
            m_close = true;
            if (m_open)  // 退出未完成的线程,关闭设备
            {
                if (m_trddown2)
                {
                    CH375DLL.CH375AbortWrite(mIndex);
                }
                if (m_trdup2)
                {
                    CH375DLL.CH375AbortRead(mIndex);
                }
                if (m_trdup1)
                {
                    CH375DLL.CH375AbortInter(mIndex);
                }
                Thread.Sleep(50);
                if (T2DHandle != new IntPtr(-1))
                {
                    winapi.CloseHandle(T2DHandle);		//关闭端点2下传句柄
                    T2DHandle = new IntPtr(-1);
                }
                if (T2UHandle != new IntPtr(-1))
                {
                    winapi.CloseHandle(T2UHandle);		//关闭端点2上传句柄
                    T2UHandle = new IntPtr(-1);
                }
                if (T1Handle != new IntPtr(-1))
                {
                    winapi.CloseHandle(T1Handle);		//关闭端点1句柄
                    T1Handle = new IntPtr(-1);
                }
                CH375DLL.CH375CloseDevice(mIndex);
                DevHandle = new IntPtr(-1);
                m_open = false;
                Thread.Sleep(20);
                this.button_OpenDev.Text = "打开设备";//等效于单击打开设备按钮
            }
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            CH375DLL.CH375SetDeviceNotify(0, null, null);//取消监视
            if (m_open)
            {
                mCloseWin();//关闭设备
            }
            return;
        }

        private void button_ClearD2_Click(object sender, EventArgs e)//清空端点2下传数据
        {
            DownCount=0;
            this.label_Down2.Text = string.Format("Down:{0:D}",DownCount);
            this.textBox_DownData.Text = "";
        }

        private void button_ClearU2_Click(object sender, EventArgs e)//清空端点2上传数据
        {
            UpCount = 0;
            this.label_Up2.Text = string.Format("Up:{0:D}", UpCount);
            this.textBox_Up2Data.Text = "";
        }

        private void button_ClearU1_Click(object sender, EventArgs e)//清空端点1上传数据
        {
            InterCount = 0;
            this.label_Up1.Text = string.Format("Up:{0:D}", InterCount);
            this.textBox_up1Data.Text = "";
        }

        private void button_Down2_Click(object sender, EventArgs e)//端点2下传
        {
	        if(!m_open)	
            {
		        MessageBox.Show("请先打开设备!","DEBUG372");
		        return;			
	        }
	        if(T2DHandle == new IntPtr(-1))
	        {
                string str = CH375DLL.CH375GetDeviceName(mIndex);//设备路径
                T2DHandle = winapi.CreateFile(str, GENERIC_READ | GENERIC_WRITE,  // 打开设备
                                                FILE_SHARE_READ | FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, IntPtr.Zero);
		        if(T2DHandle == new IntPtr(-1))
		        {
			        MessageBox.Show("无法打开设备！","DEBUG372");
			        return;
		        }
	        }
            m_downlen2 = mStrToBcd(this.textBox_DownLen.Text);
            if (m_downlen2 > CH375DLL.mCH375_PACKET_LENGTH * 64)
	        {
		        MessageBox.Show("批量下传数据长度一次最大为4096！","DEBUG372");
		        return;
	        }
            Thread D2 = new Thread(D2Thread);//新建下传线程
            D2.IsBackground = true;
            D2.Start();
	        if(D2.IsAlive)
	        {
		        m_trddown2 = true;		//线程启动标志
	        }
	        else
	        {
                m_trddown2 = false;
		        MessageBox.Show("端点2下传线程启动失败","DEBUG372");
		        return;
	        }
        }
        ///////////////////////////////////////////////////////////////////////////
        public void D2Thread()//端点2下传线程
        {
            Thread.Sleep(100);
            uint dlen,datalen;
	        byte[] mBuf=new byte[CH375DLL.mCH375_PACKET_LENGTH*8];
            this.button_Down2.Enabled=false;
	        if(m_open && m_trddown2)
	        {
		        /**************在线程中用CreateFile打开设备,因为每个句柄同一时候只能执行一个API**************************/		
		        if ( T2DHandle != new IntPtr(-1) ) 
		        {
			        datalen =(uint) this.textBox_DownData.Text.Length;
			        if(datalen/2 >= m_downlen2)		//取数据长度与输入长度中偏小值
				        datalen = m_downlen2;		
			        else{
				        datalen = datalen/2;
                        this.textBox_DownLen.Text=datalen.ToString();//更新下传长度显示
				        m_downlen2 = datalen;
			        }
                    string str=this.textBox_DownData.Text;
                    byte[] buf=Encoding.Default.GetBytes(str);
			        mem_cpy(mBuf,0,buf,0,datalen*2);
			        byte[] StrVal=mStrtoVal(mBuf,datalen*2);
			        dlen = datalen;			
			        if(!CH375DLL.CH375WriteData((uint)T2DHandle,StrVal,ref dlen))
			        {
				        if (!m_close) 
                            MessageBox.Show("端点2下传失败！如果设备断开过那么请先关闭本程序","DEBUG372");
			        }
			        else
                    {//更新累计长度显示
				        DownCount=DownCount+dlen;
				        this.label_Down2.Text=string.Format("Down: {0:D}",DownCount);
			        }
		        }
	        }
	       m_trddown2 = false;
	       this.button_Down2.Enabled=true;
        }

        private void button_Up2_Click(object sender, EventArgs e)//端点2上传
        {
            if (!m_open)
            {
                MessageBox.Show("请先打开设备!", "DEBUG372");
                return;
            }
            if (T2UHandle == new IntPtr(-1))
            {
                string str = CH375DLL.CH375GetDeviceName(mIndex);
                T2UHandle = winapi.CreateFile(str, GENERIC_READ | GENERIC_WRITE,  // 打开设备
                                                FILE_SHARE_READ | FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, IntPtr.Zero);
                if (T2UHandle == new IntPtr(-1))
                {
                    MessageBox.Show("无法打开设备！", "DEBUG372");
                    return;
                }
            }
            m_uplen2 = mStrToBcd(this.textBox_Up2Len.Text);
            if (m_uplen2 > CH375DLL.mCH375_PACKET_LENGTH * 8)
            {
                MessageBox.Show("上传长度无效！", "DEBUG372");
                return;
            }
            Thread U2 = new Thread(U2Thread);//新建上传线程
            U2.IsBackground = true;
            U2.Start();
            if (U2.IsAlive)
            {
                m_trdup2 = true;		//线程启动标志
            }
            else
            {
                MessageBox.Show("端点2上传线程启动失败", "DEBUG372");
                m_trdup2 = false;
                return;
            }
            
        }
        public void U2Thread()//端点2上传线程
        {
            Thread.Sleep(100);
            uint dlen, datalen;
            byte[] mBuf = new byte[CH375DLL.mCH375_PACKET_LENGTH * 8];
            this.button_Up2.Enabled = false;
            if (m_open && m_trdup2)
            {
                /**************在线程中用CreateFile打开设备,因为每个句柄同一时候只能执行一个API**************************/
                if (T2UHandle != new IntPtr(-1))
                {
                    if (mBuf.Length >= m_uplen2)//取数据长度与输入长度中偏小值
                        datalen = m_uplen2;
                    else
                    {
                        datalen = (uint)mBuf.Length;
                        m_uplen2 = datalen;
                    }
                    dlen = datalen;
                    if (CH375DLL.CH375ReadData((uint)T2UHandle, mBuf, ref dlen))//上传数据
                    {
                        string strbuf="";
                        byte[] buffer = new byte[CH375DLL.mCH375_PACKET_LENGTH *8*2+1];
                        for (uint k = 0; k < dlen; k++)
                        {
                            strbuf = strbuf+mBuf[k].ToString("X2") + " ";
                        }
                        if (this.textBox_Up2Data.Text == "")
                            this.textBox_Up2Data.Text = strbuf;
                        else
                            this.textBox_Up2Data.AppendText("\r\n" + strbuf);
                        //更新累计长度显示
                        UpCount = UpCount + dlen;
                        this.label_Up2.Text = string.Format("UP: {0:D}", UpCount);
                    }
                    else if(!m_close)
                    {
                        MessageBox.Show("端点2下传失败！如果设备断开过那么请先关闭本程序", "DEBUG372");
                    }
                }
            }
            m_trdup2 = false;
            this.button_Up2.Enabled = true;
        }

        private void button_Up1_Click(object sender, EventArgs e)//端点1上传
        {
	        if(!m_open)	
            {
		        MessageBox.Show("请先打开设备!","DEBUG372");
		        return;			
	        }
	        if(T1Handle == new IntPtr(-1))
	        {
                string str = CH375DLL.CH375GetDeviceName(mIndex);
                T1Handle = winapi.CreateFile(str, GENERIC_READ | GENERIC_WRITE,  // 打开设备
                                                FILE_SHARE_READ | FILE_SHARE_WRITE, IntPtr.Zero, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, IntPtr.Zero);
                if (T1Handle == new IntPtr(-1))
                {
                    MessageBox.Show("无法打开设备！", "DEBUG372");
                    return;
                }
	        }
            m_uplen1 = mStrToBcd(this.textBox_Up1Len.Text);
	        if((m_uplen1 > 8))
	        {
		        MessageBox.Show("中断上传长度长度不大于8","DEBUG372");
		        return;
	        }
            //建立线程
            Thread U1 = new Thread(U1Thread);
            U1.IsBackground = true;
            U1.Start();
            if (U1.IsAlive)
            {
                m_trdup1 = true;		//线程启动标志
            }
            else
            {
                MessageBox.Show("端点1上传线程启动失败", "DEBUG372");
                m_trdup1 = false;
                return;
            }
        }
        public void U1Thread()//端点1上传线程
        {
            Thread.Sleep(100);
            byte[] mBuf=new byte[CH375DLL.mCH375_PACKET_LENGTH*8];
	        uint dlen,datalen;
            this.button_Up1.Enabled=false;
	        if(m_open && m_trdup1)
	        {
		        /**************在线程中用CreateFile打开设备,因为每个句柄同一时候只能执行一个API**************************/

		        if ( T1Handle != new IntPtr(-1) ) 
		        {
			        datalen = m_uplen1;
			        dlen = datalen;
			        if(CH375DLL.CH375ReadInter((uint)T1Handle,mBuf,ref dlen))
			        {
                        string up1buf="";
                        for(uint j=0;j<dlen;j++)
                        {
                            up1buf=up1buf+mBuf[j].ToString("X2")+" ";
                        }
                        this.textBox_up1Data.Text=up1buf;
					    InterCount=InterCount+dlen;//更新累计上传长度显示
                        this.label_Up1.Text = string.Format("Up: {0:D}", InterCount);
			        }
			        else if (!m_close) 
                        MessageBox.Show("端点1上传失败！如果设备断开过那么请先关闭本程序","DEBUG372");
		        }
	        }
	        m_trdup1 = false;
	        this.button_Up1.Enabled=true;
	        return ;
        }
    }
}
